if select(2, UnitClass("player")) ~= "DRUID" then return end
local GetSpellInfo = GetSpellInfo
local IsEquippedItem = IsEquippedItem
local UnitStat = UnitStat
local UnitExists = UnitExists
local UnitIsUnit = UnitIsUnit

--No base increase on: Insect Swarm, Rejuvenation, Entangling Roots, Lifebloom

function DrDamage:PlayerData()

	--Special calculation		
	
	--General
	local tol, tol2 = GetSpellInfo(48371)
	local moonkin = GetSpellInfo(24858)
	local mas = GetSpellInfo(48412)
	self.Calculation["DRUID"] = function( calculation, ActiveAuras, BuffTalentRanks, spell )
		if calculation.healingSpell then
			if BuffTalentRanks["Master Shapeshifter"] and UnitBuff("player", tol, tol2) and calculation.spellName ~= "Lifebloom" then
				calculation.dmgM = calculation.dmgM * (1 + BuffTalentRanks["Master Shapeshifter"])
			end
		else
			if BuffTalentRanks["Naturalist"] then
				calculation.dmgM = calculation.dmgM / ( 1 + BuffTalentRanks["Naturalist"] )
			end
			if BuffTalentRanks["Improved Faerie Fire"] and ActiveAuras["Faerie Fire"] then
				calculation.critPerc = calculation.critPerc + 1 * BuffTalentRanks["Improved Faerie Fire"]
				calculation.hitPerc = calculation.hitPerc + 1 * BuffTalentRanks["Improved Faerie Fire"]
			end
			--[[ NOTE: I believe these are accounted for by API
			if ActiveAuras["Owlkin Frenzy"] then
				calculation.dmgM = calculation.dmgM * 1.1
			end
			if BuffTalentRanks["King of the Jungle"] and GetShapeShiftForm(true) == 1 and ActiveAuras["Enrage"] then
				calculation.dmgM = calculation.dmgM * (1 + (0.05 * BuffTalentRanks["King of the Jungle"]))
			end
			--]]
			if UnitBuff("player", moonkin) and BuffTalentRanks["Master Shapeshifter"] then
				calculation.dmgM = calculation.dmgM * (1 + BuffTalentRanks["Master Shapeshifter"])
			end
		end
	end
	self.Calculation["Gift of the Earthmother"] = function( calculation, talentValue )
		calculation.castTime = calculation.castTime * ( 1 - talentValue )
	end
	self.Calculation["Lifebloom"] = function( calculation, _, Talents, _, baseSpell )
		if UnitExists("target") and not UnitIsUnit("target","player") then
			if UnitBuff("target",tol, tol2) and UnitBuff("target",mas) then
				calculation.dmgM = calculation.dmgM * 1.04
			elseif Talents["Master Shapeshifter"] and UnitBuff("player",tol, tol2) then
				calculation.dmgM_dot = calculation.dmgM_dot * (1 + Talents["Master Shapeshifter"])
			end
		else
			if Talents["Master Shapeshifter"] and UnitBuff("player",tol, tol2) then
				calculation.dmgM = calculation.dmgM * (1 + Talents["Master Shapeshifter"])
			end
		end	
		--Glyph of Lifebloom
		if self:HasGlyph(54826) then
			calculation.eDuration = calculation.eDuration + 1
		end
		--Idol of Lush Moss
		if IsEquippedItem(40711) then
			calculation.hybridDotDmg = calculation.hybridDotDmg + 125 * baseSpell.dotFactor
		--Idol of the Emerald Queen
		elseif IsEquippedItem(27886) then
			calculation.hybridDotDmg = calculation.hybridDotDmg + 47 * baseSpell.dotFactor
		end	
	end	
	
	--Spell specific
	--Nourish bonus if Rejuvenation, Regrowth, Lifebloom, or Wild Growth are active on the target
	self.Calculation["Nourish"] = function( calculation, ActiveAuras )
		local hotCount = 0
		if ActiveAuras["Rejuvenation"] then hotCount = hotCount + 1 end
		if ActiveAuras["Regrowth"] then hotCount = hotCount + 1 end
		if ActiveAuras["Lifebloom"] then hotCount = hotCount + 1 end
		if ActiveAuras["Wild Growth"] then hotCount = hotCount + 1 end
		if hotCount > 0 then
			local bonus = 0
			if self:GetSetAmount( "Dreamwalker Regalia" ) >= 4 then
				bonus = bonus + 0.05 * hotCount
			end
			--Glyph of Nourish
			if self:HasGlyph(62971) then
				bonus = bonus + 0.06 * hotCount
			end
			calculation.dmgM = calculation.dmgM * (1.2 + bonus)
		end
	end
	self.Calculation["Healing Touch"] = function( calculation )
		--Glyph of Healing Touch
		if self:HasGlyph(54825) then
			calculation.dmgM = calculation.dmgM * 0.5
		end
	end
	self.Calculation["Regrowth"] = function( calculation, ActiveAuras )
		--Glyph of Regrowth
		if self:HasGlyph(54743) and ActiveAuras["Regrowth"] then
			calculation.dmgM = calculation.dmgM * 1.2
		end
	end
	self.Calculation["Rejuvenation"] = function( calculation, ActiveAuras )
		--Glyph of Rejuvenation
		if self:HasGlyph(54754) and (UnitHealth("target") / UnitHealthMax("target") < 0.5) then
			calculation.dmgM = calculation.dmgM * 1.5
		end
	end
	self.Calculation["Moonfire"] = function( calculation )
		--Glyph of Moonfire
		if self:HasGlyph(54829) then
			--Bonuses/penalties are additive, applied directly to talent effects
			local penalty = 0.9 - calculation.dmgM_Add
			calculation.dmgM_dd = calculation.dmgM_dd - penalty
			calculation.dmgM_dot_Add = calculation.dmgM_Add + 0.75
			calculation.dmgM_Add = 0
		end
	end
	self.Calculation["Starfire"] = function( calculation, ActiveAuras, BuffTalentRanks, spell )
		if ActiveAuras["Moonfire"] and BuffTalentRanks["Improved Insect Swarm"] then
			calculation.critPerc = calculation.critPerc + BuffTalentRanks["Improved Insect Swarm"]
		end
		--Idol of the Shooting Star, doesn't get talent bonus, only target debuffs
		if IsEquippedItem(40321) then
			calculation.finalMod = calculation.finalMod + 165 * calculation.dmgM / (1 + (BuffTalentRanks["Earth And Moon"] or 0))
		--Ivory Idol of the Moongoddess
		elseif IsEquippedItem(27518) then
			calculation.finalMod = calculation.finalMod + 55 * calculation.dmgM / (1 + (BuffTalentRanks["Earth And Moon"] or 0))
		end	
	end
	self.Calculation["Starfall"] = function( calculation )
		--Glyph of Focus
		if self:HasGlyph(62080) then
			calculation.dmgM = calculation.dmgM * 1.2
		end
	end
	self.Calculation["Wrath"] = function( calculation, ActiveAuras, BuffTalentRanks, spell )
		if ActiveAuras["Insect Swarm"] and BuffTalentRanks["Improved Insect Swarm"] then
			calculation.dmgM = calculation.dmgM * (1 + (BuffTalentRanks["Improved Insect Swarm"] * 0.01))
		end
	end
	self.Calculation["Insect Swarm"] = function( calculation )
		--Glyph of Insect Swarm
		if self:HasGlyph(54830) then
			calculation.dmgM_Add = calculation.dmgM_Add + 0.3
		end
	end
 	self.Calculation["Maul"] = function( calculation, ActiveAuras, BuffTalentRanks, spell )
		if BuffTalentRanks["Rend and Tear"] and ActiveAuras["Bleeding"] then
			calculation.dmgM = calculation.dmgM * (1 + (0.04 * BuffTalentRanks["Rend and Tear"]))
		end
	end
	self.Calculation["Shred"] = function( calculation, ActiveAuras, BuffTalentRanks, spell )
		if BuffTalentRanks["Rend and Tear"] and ActiveAuras["Bleeding"] then
			calculation.dmgM = calculation.dmgM * (1 + (0.04 * BuffTalentRanks["Rend and Tear"]))
		end
	end
	self.Calculation["Rip"] = function( calculation )
		--Glyph of Rip
		if self:HasGlyph(54818) then
			calculation.eDuration = calculation.eDuration + 4
		end
	end
	self.Calculation["Ferocious Bite"] = function( calculation, ActiveAuras, BuffTalentRanks, spell )
		if BuffTalentRanks["Rend and Tear"] and ActiveAuras["Bleeding"] then
			calculation.dmgM = calculation.dmgM * (1 + (0.04 * BuffTalentRanks["Rend and Tear"]))
		end
	end	
	
	--Set bonuses
	
	--Sets
	self.SetBonuses["Dreamwalker Battlegear"] = { 40471, 40472, 40473, 40493, 40494, 39553, 39554, 39555, 39556, 39557 }
	self.SetBonuses["Dreamwalker Garb"] = { 40466, 40467, 40468, 40469, 40470, 39544, 39545, 39546, 39547, 39548 }
	self.SetBonuses["Dreamwalker Regalia"] = { 40460, 40461, 40462, 40463, 40465, 39531, 39538, 39539, 39542, 39543 }
	self.SetBonuses["T8 Moonkin"] = { 46189, 46191, 46192, 46194, 45196, 45351, 45352, 45353, 45354, 46414 }
	--TODO: 4p T8 Healer
	
	--Effects
	self.SetBonuses["Lacerate"] = function( calculation )
		if self:GetSetAmount("Dreamwalker Battlegear" ) >= 2 then
			calculation.dmgM = calculation.dmgM * 1.05
		end
		if IsEquippedItem(27744) then --Idol of Ursoc
			calculation.extraDamBonus = calculation.extraDamBonus + 8
			calculation.minDam = calculation.minDam + 8
			calculation.maxDam = calculation.maxDam + 8
		end
	end
	self.SetBonuses["Rip"] = function( calculation )
		if self:GetSetAmount( "Dreamwalker Battlegear" ) >= 2 then
			calculation.eDuration = calculation.eDuration + 2
		end
		if IsEquippedItem(39757) then --Idol of Worship
			local cp = calculation.Melee_ComboPoints
			calculation.minDam = calculation.minDam + 21 * cp
			calculation.maxDam = calculation.maxDam + 21 * cp		
		elseif IsEquippedItem(28372) then --Idol of Feral Shadows
			local cp = calculation.Melee_ComboPoints
			calculation.minDam = calculation.minDam + 7 * cp
			calculation.maxDam = calculation.maxDam + 7 * cp
		end
	end
	self.SetBonuses["Insect Swarm"] = function (calculation )
		if self:GetSetAmount("Dreamwalker Garb" ) >= 2 then
			calculation.dmgM_Add = calculation.dmgM_Add + 0.1
		end
	end
	self.SetBonuses["Wrath"] = function (calculation )
		if self:GetSetAmount("Dreamwalker Garb" ) >= 4 then
			calculation.critPerc = calculation.critPerc + 5
		end
	end
	
	--Relic slot items:
	--Brutal Gladiator's Idol of Tenacity, Deadly Gladiator's Idol of Tenacity, Furious Gladiator's Idol of Tenacity, Gladiator's Idol of Tenacity, Hateful Gladiator's Idol of Tenacity, Merciless Gladiator's Idol of Tenacity, Vengeful Gladiator's Idol of Tenacity, Savage Gladiator's Idol of Tenacity
	self.RelicSlot["Lifebloom"] = { 35021, 131, 42578, 246, 42579, 294, 28355, 87, 42577, 217, 33076, 105, 33841, 116, 42576, 188,  ModType1 = "finalMod", ModType2 = "finalMod", ModType3 = "finalMod", ModType4 = "finalMod", ModType5 = "finalMod", ModType6 = "finalMod", ModType7 = "finalMod", ModType8 = "finalMod", }
	--Idol of Pure Thoughts (TODO: verify), Harold's Rejuvenating Broach, Idol of Rejuvenation
	self.RelicSlot["Rejuvenation"] = { 38366, 132, 25643, 86, 22398, 50, ModType1 = "Base" }	
	--Idol of the Avian Heart, Idol of Health
	self.RelicSlot["Healing Touch"] = { 28568, 136, 22399, 100, ModType1 = "Base", ModType2 = "Base" }
	--Idol of Steadfast Renewal, Idol of the Avenger	
	self.RelicSlot["Wrath"] = { 40712, 70, 31025, 25, ModType1 = "Base", ModType2 = "Base" }
	--Idol of the Moon
	self.RelicSlot["Moonfire"] = { 23197, 33 }											
	--Idol of the Crying Wind
	self.RelicSlot["Insect Swarm"] = { 45270, 374 }
	--Idol of the Flourishing Life
	self.RelicSlot["Nourish"] = { 46138, 187 }
	
	--Idol of the Ravenous Beast, Everbloom idol
	self.RelicSlot["Shred"] = { 40713, 203, 29390, 88, }
	--Idol of the Wild
	self.RelicSlot["Mangle (Cat)"] = { 28064, 24, } 
	self.RelicSlot["Mangle (Bear)"] = { 28064, 51.75, }
	--Idol of Perspicacious Attacks, Idol of Brutality
	self.RelicSlot["Maul"] = { 38365, 120, 23198, 50 } 
	self.RelicSlot["Swipe"] = { 38365, 24, 23198, 10 }
	--Idol of Ferocity, Idol of Savagery (Horde), Idol of Savagery (Alliance)
	self.RelicSlot["Rake"] = { 22397, 20, 27989, 30, 27990, 30 } 
	self.RelicSlot["Claw"] = { 22397, 20, 27989, 30, 27990, 30 }
	
	--AURA
	--Nature's Grace
	self.PlayerAura[GetSpellInfo(16880)] = { ModType = "Update" }
	--Eclipse
	self.PlayerAura[GetSpellInfo(48517)] = { Spell = { GetSpellInfo(5176), GetSpellInfo(2912) }, ModType = "Special" }
	--Enrage
	self.PlayerAura[GetSpellInfo(5229)] = { ModType = "ActiveAura", ActiveAura = "Enrage" }	
	--Moonfire
	--Insect Swarm	
	self.TargetAura[GetSpellInfo(8921)] = { Spell = GetSpellInfo(2912), ModType = "ActiveAura", ActiveAura = "Moonfire", }
	self.TargetAura[GetSpellInfo(5570)] = { Spell = { GetSpellInfo(2912), GetSpellInfo(5176) }, ModType = "ActiveAura", ActiveAura = "Insect Swarm", }
	--Rejuvenation (for Nourish bonus)
	--Regrowth (for Nourish bonus)
	--Lifebloom (for Nourish bonus)
	--Wild Growth (for Nourish bonus)
	self.TargetAura[GetSpellInfo(774)] = { Spell = GetSpellInfo(50464), ModType = "ActiveAura", ActiveAura="Rejuvenation", }
	self.TargetAura[GetSpellInfo(16561)] = { Spell = GetSpellInfo(50464), ModType = "ActiveAura", ActiveAura="Regrowth", }
	self.TargetAura[GetSpellInfo(33763)] = { Spell = GetSpellInfo(50464), ModType = "ActiveAura", ActiveAura="Lifebloom", }
	self.TargetAura[GetSpellInfo(48438)] = { Spell = GetSpellInfo(50464), ModType = "ActiveAura", ActiveAura="Wild Growth", }
	--Faerie Fire
	--Master Shapeshifter
	self.TargetAura[GetSpellInfo(770)] = { ModType = "ActiveAura", ActiveAura = "Faerie Fire", SelfCast = true, }
	self.TargetAura[GetSpellInfo(48412)] = { ModType = "Update" }
	
	
	--NOTE: are these needed?
	--Master Shapshifter
	--self.PlayerAura[GetSpellInfo(48411)] = { ModType = "ActiveAura", ActiveAura = "Master Shapeshifter" }
	--Owlkin Frenzy
	--self.PlayerAura[GetSpellInfo(48391)] = { ModType = "ActiveAura", ActiveAura = "Owlkin Frenzy", }	
	
	--Target bleed effects
	--Deep Wound
	--Rend
	--Garrote
	--Rupture
	--Lacerate
	--Pounce
	--Rip
	--Rake
	--Piercing Shots
	self.TargetAura[GetSpellInfo(43104)] = {ModType = "ActiveAura", ActiveAura = "Bleeding", }
	self.TargetAura[GetSpellInfo(16403)] = {ModType = "ActiveAura", ActiveAura = "Bleeding", }
	self.TargetAura[GetSpellInfo(703)] = {ModType = "ActiveAura", ActiveAura = "Bleeding", }
	self.TargetAura[GetSpellInfo(1943)] = {ModType = "ActiveAura", ActiveAura = "Bleeding", }
	self.TargetAura[GetSpellInfo(33745)] = {ModType = "ActiveAura", ActiveAura = "Bleeding", }
	self.TargetAura[GetSpellInfo(9005)] = {ModType = "ActiveAura", ActiveAura = "Bleeding", }
	self.TargetAura[GetSpellInfo(1079)] = {ModType = "ActiveAura", ActiveAura = "Bleeding", }
	self.TargetAura[GetSpellInfo(59881)] = {ModType = "ActiveAura", ActiveAura = "Bleeding", }
	self.TargetAura[GetSpellInfo(63468)] = {ModType = "ActiveAura", ActiveAura = "Bleeding", }
	
	self.Calculation[GetSpellInfo(48517)] = function( calculation, _, _, _, _, texture )
		if texture == "Interface\\Icons\\Ability_Druid_EclipseOrange" then
			calculation.dmgM = calculation.dmgM * (1.3 + ((self:GetSetAmount("T8 Moonkin" ) >= 2) and 0.15 or 0))
		else
			calculation.critPerc = calculation.critPerc + 30 + ((self:GetSetAmount("T8 Moonkin" ) >= 2) and 15 or 0)
		end
	end
	
	self.spellInfo = {
		--TODO: STARFALL COEFFICIENT (VERIFY)
		[GetSpellInfo(5176)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					["Name"] = "Wrath",
					[0] = { School = "Nature", canCrit = true, castTime = 2, BaseIncrease = true },
					[1] = { 17, 19, 31, 32, spellLevel = 1, castTime = 1.5, },
					[2] = { 32, 36, 44, 45, spellLevel = 6, castTime = 1.7, },
					[3] = { 49, 57, 52, 53, spellLevel = 14, },
					[4] = { 68, 78, 58, 58, spellLevel = 22, },
					[5] = { 130, 148, 65, 65, spellLevel = 30, },
					[6] = { 169, 191, 67, 68, spellLevel = 38, },
					[7] = { 215, 241, 61, 62, spellLevel = 46, },
					[8] = { 306, 344, 54, 55, spellLevel = 54, },
					[9] = { 397, 447, 45, 46, spellLevel = 61, },
					[10] = { 431, 485, 29, 30, spellLevel = 69, },
					[11] = { 504, 568, 18, 18, spellLevel = 74, },
					[12] = { 553, 623, 4, 4, spellLevel = 79, },
		},
		[GetSpellInfo(27012)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					--TODO: OLD STYLE INCREASE?
					["Name"] = "Hurricane",
					[0] = { School = "Nature", canCrit = true, castTime = 10, sHits = 10, bonusFactor = 1.28962, BaseIncrease = true },
					[1] = { 100, 100, 1, 2, spellLevel = 40, },
					[2] = { 142, 142, 1, 2, spellLevel = 50, },
					[3] = { 190, 190, 1, 2, spellLevel = 60, },
					[4] = { 303, 303, 2, 3, spellLevel = 70, },
					[5] = { 451, 451, 0, 0, spellLevel = 80, },
		},
		[GetSpellInfo(5570)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					["Name"] = "Insect Swarm",
					[0] = { School = "Nature", bonusFactor = 1.2, eDot = true, eDuration = 12, sTicks = 2, },
					[1] = { 144, 144, spellLevel = 30 },
					[2] = { 234, 234, spellLevel = 30 },
					[3] = { 372, 372, spellLevel = 40 },
					[4] = { 540, 540, spellLevel = 50 },
					[5] = { 744, 744, spellLevel = 60 },
					[6] = { 1032, 1032, spellLevel = 70 },
					[7] = { 1290, 1290, spellLevel = 80 },
		},		
		[GetSpellInfo(8921)] = {
					["Name"] = "Moonfire",
					--Coefficient: 0.1515 or 0.15?
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK(?)
					[0] = { School = "Arcane", canCrit = true, bonusFactor = 0.15, dotFactor = 0.52, eDuration = 12, sTicks = 3, BaseIncrease = true },
					[1] = { 7, 9, 38, 38, hybridDotDmg = 12, spellLevel = 4, },
					[2] = { 13, 17, 56, 56, hybridDotDmg = 32, spellLevel = 10 },
					[3] = { 25, 31, 70, 71, hybridDotDmg = 52, spellLevel = 16, },
					[4] = { 40, 48, 81, 82, hybridDotDmg = 80, spellLevel = 22, },
					[5] = { 61, 73, 93, 94, hybridDotDmg = 124, spellLevel = 28, },
					[6] = { 81, 97, 96, 97, hybridDotDmg = 164, spellLevel = 34, },
					[7] = { 105, 125, 96, 96, hybridDotDmg = 212, spellLevel = 40, },
					[8] = { 130, 154, 91, 92, hybridDotDmg = 264, spellLevel = 46, },
					[9] = { 157, 185, 84, 84, hybridDotDmg = 320, spellLevel = 52, },
					[10] = { 189, 221, 72, 73, hybridDotDmg = 384, spellLevel = 58, },
					[11] = { 220, 258, 61, 62, hybridDotDmg = 444, spellLevel = 63, },
					[12] = { 305, 357, 39, 39, hybridDotDmg = 600, spellLevel = 70, },
					[13] = { 347, 407, 25, 25, hybridDotDmg = 684, spellLevel = 75, },
					[14] = { 406, 476, 0, 0, hybridDotDmg = 800, spellLevel = 80, },
		},
		[GetSpellInfo(2912)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					["Name"] = "Starfire",
					[0] = { School = "Arcane", canCrit = true, castTime = 3.5, BaseIncrease = true },
					[1] = { 121, 149, 72, 72, spellLevel = 20, },
					[2] = { 189, 231, 86, 87, spellLevel = 26, },
					[3] = { 272, 328, 87, 88, spellLevel = 34, },
					[4] = { 370, 442, 87, 88, spellLevel = 42, },
					[5] = { 485, 575, 81, 81, spellLevel = 50, },
					[6] = { 615, 725, 66, 66, spellLevel = 58, },
					[7] = { 693, 817, 62, 62, spellLevel = 60, },
					[8] = { 818, 964, 44, 45, spellLevel = 67, },
					[9] = { 854, 1006, 32, 32, spellLevel = 72, },
					[10] = { 1028, 1212, 10, 10, spellLevel = 78, },
		},
		[GetSpellInfo(339)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					--Downranks ranks 1 and 2
					["Name"] = "Entangling Roots",
					[0] = { School = "Nature", eDot = true, eDuration = 27, sFactor = 0.5, sTicks = 3, NoDownRank = true },
					[1] = { 20, 20, spellLevel = 8, eDuration = 12, },
					[2] = { 50, 50, spellLevel = 18, eDuration = 15, },
					[3] = { 90, 90, spellLevel = 28, eDuration = 18, },
					[4] = { 140, 140, spellLevel = 38, eDuration = 21, },
					[5] = { 200, 200, spellLevel = 48, eDuration = 24, },
					[6] = { 270, 270, spellLevel = 58, },
					[7] = { 351, 351, spellLevel = 68, },
					[8] = { 423, 423, spellLevel = 78, },
		},
		[GetSpellInfo(50516)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					["Name"] = "Typhoon",
					[0] = { School = "Nature", canCrit = true, bonusFactor = 0.193, Cooldown = 20 },
					[1] = { 400, 400, spellLevel = 50, },
					[2] = { 550, 550, spellLevel = 60, },
					[3] = { 735, 735, spellLevel = 70, },
					[4] = { 1010, 1010, spellLevel = 75, },
					[5] = { 1190, 1190, spellLevel = 80, },
		},
		[GetSpellInfo(48505)] = {
					--BASE OK, INCREASE OK, COEFFICIENT X
					-- TODO: Need to implement AoE from each shard?
					["Name"] = "Starfall",
					[0] = { School = "Arcane", canCrit = true, bonusFactor = 0.916, castTime = 10, sHits = 20 },
					[1] = { 111, 129, spellLevel = 60, },
					[2] = { 250, 290, spellLevel = 70, },
					[3] = { 366, 424, spellLevel = 75, },
					[4] = { 433, 503, spellLevel = 80, },
		},
		[GetSpellInfo(5185)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					["Name"] = "Healing Touch",
					[0] = { School = { "Nature", "Healing", }, canCrit = true, castTime = 3.0, BaseIncrease = true },
					[1] = { 37, 51, 63, 64, spellLevel = 1, castTime = 1.5, },
					[2] = { 88, 112, 93, 94, spellLevel = 8, castTime = 2, },
					[3] = { 195, 243, 125, 126, spellLevel = 14, castTime = 2.5, },
					[4] = { 363, 445, 162, 162, spellLevel = 20, },
					[5] = { 490, 594, 162, 162, spellLevel = 26, },
					[6] = { 636, 766, 163, 164, spellLevel = 32, },
					[7] = { 802, 960, 163, 164, spellLevel = 38, },					
					[8] = { 1199, 1427, 162, 162, spellLevel = 44, },
					[9] = { 1299, 1539, 153, 153, spellLevel = 50, },
					[10] = { 1620, 1912, 136, 137, spellLevel = 56, },
					[11] = { 1944, 2294, 124, 124, spellLevel = 60, },
					[12] = { 2026, 2392, 113, 114, spellLevel = 62, },
					[13] = { 2321, 2739, 77, 77, spellLevel = 69, },
					[14] = { 3223, 3805, 58, 59, spellLevel = 74, },
					[15] = { 3750, 4428, 11, 12, spellLevel = 79, },
		},
		[GetSpellInfo(774)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					["Name"] = "Rejuvenation",
					[0] = { School = { "Nature", "Healing", }, eDot = true, eDuration = 12, sTicks = 3, },
					[1] = { 32, 32, spellLevel = 4, },
					[2] = { 56, 56, spellLevel = 10, },
					[3] = { 116, 116, spellLevel = 16, },
					[4] = { 180, 180, spellLevel = 22, },
					[5] = { 244, 244, spellLevel = 28, },
					[6] = { 304, 304, spellLevel = 34, },
					[7] = { 388, 388, spellLevel = 40, },
					[8] = { 488, 488, spellLevel = 46, },
					[9] = { 608, 608, spellLevel = 52, },
					[10] = { 756, 756, spellLevel = 58, },
					[11] = { 888, 888, spellLevel = 60, },
					[12] = { 932, 932, spellLevel = 63, },
					[13] = { 1060, 1060, spellLevel = 69, },
					[14] = { 1192, 1192, spellLevel = 75, },
					[15] = { 1690, 1690, spellLevel = 80, eDuration = 15, },
		},
		[GetSpellInfo(8936)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					["Name"] = "Regrowth",
					[0] = { School = { "Nature", "Healing", }, canCrit = true, castTime = 2, bonusFactor = 0.2867, dotFactor = 1.316, eDuration = 21, sTicks = 3, BaseIncrease = true },
					[1] = { 84, 98, 122, 123, hybridDotDmg = 98, spellLevel = 12, },
					[2] = { 164, 188, 155, 155, hybridDotDmg = 175, spellLevel = 18, },
					[3] = { 240, 274, 173, 174, hybridDotDmg = 259, spellLevel = 24, },
					[4] = { 318, 360, 180, 180, hybridDotDmg = 343, spellLevel = 30, },
					[5] = { 405, 457, 180, 181, hybridDotDmg = 427, spellLevel = 36, },
					[6] = { 511, 575, 178, 179, hybridDotDmg = 546, spellLevel = 42, },
					[7] = { 646, 724, 169, 170, hybridDotDmg = 686, spellLevel = 48, },
					[8] = { 809, 905, 156, 156, hybridDotDmg = 861, spellLevel = 54, },
					[9] = { 1003, 1119, 136, 136, hybridDotDmg = 1064, spellLevel = 60, },
					[10] = { 1215, 1355, 115, 116, hybridDotDmg = 1274, spellLevel = 65, },
					[11] = { 1710, 1908, 97, 98, hybridDotDmg = 1792, spellLevel = 71, },
					[12] = { 2234, 2494, 23, 24, hybridDotDmg = 2345, spellLevel = 77, },
		},
		[GetSpellInfo(740)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					["Name"] = "Tranquility",
					[0] = { School = { "Nature", "Healing", }, bonusFactor = 1.144681, castTime = 8, Cooldown = 600, sHits = 4, BaseIncrease = true },
					[1] = { 351, 351, 13, 13, spellLevel = 30, },
					[2] = { 515, 515, 15, 15, spellLevel = 40, },
					[3] = { 765, 765, 20, 20, spellLevel = 50, },
					[4] = { 1097, 1097, 22, 22, spellLevel = 60, },
					[5] = { 1518, 1518, 0, 0,  spellLevel = 70, },
					[6] = { 2598, 2598, 0, 0, spellLevel = 75, },
					[7] = { 3035, 3035, 0, 0, spellLevel = 80, },
		},
		[GetSpellInfo(33763)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					["Name"] = "Lifebloom",
					[0] = { School = { "Nature", "Healing" }, canCrit = true, eDuration = 7, sTicks = 1, bonusFactor = 0.34324, dotFactor = 0.66626, DotStacks = 3 },
					[1] = { 600, 600, hybridDotDmg = 224, spellLevel = 64, },	
					[2] = { 770, 770, hybridDotDmg = 287, spellLevel = 72, },
					[3] = { 970, 970, hybridDotDmg = 371, spellLevel = 80, },				
		},
		[GetSpellInfo(48438)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					--TODO: Implement tick calculation differently?
					["Name"] = "Wild Growth",
					[0] = { School = { "Nature", "Healing" }, bonusFactor = 1.5/3.5, eDot = true, eDuration = 7, sTicks = 1, },
					[1] = { 686, 686, spellLevel = 60, },
					[2] = { 861, 861, spellLevel = 70, },
					[3] = { 1239, 1239, spellLevel = 75, },
					[4] = { 1442, 1442, spellLevel = 80, },
		},
		[GetSpellInfo(50464)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					["Name"] = "Nourish",
					[0] = { School = { "Nature", "Healing" }, bonusFactor = 0.358005, canCrit = true, castTime = 1.5, },
					[1] = { 1883, 2187, spellLevel = 80, },
		},
		--TODO: add Swiftmend
		--Feral
		[GetSpellInfo(6807)] = {
					["Name"] = "Maul",
					[0] = { Rage = 15, Melee = true, WeaponDamage = 1, requiresForm = 1, NextMelee = true },
					[1] = { 18 },
					[2] = { 27 },
					[3] = { 37 },
					[4] = { 64 },
					[5] = { 103 },
					[6] = { 145 },
					[7] = { 192 },
					[8] = { 290 },
					[9] = { 472 },
					[10] = { 578 },
		},
		[GetSpellInfo(779)] = {
					["Name"] = "Swipe (Bear)",
					[0] = { Rage = 20, Melee = true, requiresForm = 1, APBonus = 0.063 },
					[1] = { 9 },
					[2] = { 13 },
					[3] = { 19 },
					[4] = { 37 },
					[5] = { 54 },
					[6] = { 76 },
					[7] = { 95 },
					[8] = { 108 },
		},
		[GetSpellInfo(62078)] = { 
					["Name"] = "Swipe (Cat)",
					[0] = { Energy = 50, Melee = true, WeaponDamage = 2.6, requiresForm = 3 },
					[1] = { 0 },
		},
		[GetSpellInfo(1082)] = {
					["Name"] = "Claw",
					[0] = { Energy = 45, WeaponDamage = 1, Melee = true, requiresForm = 3 },
					[1] = { 27 },
					[2] = { 39 },
					[3] = { 57 },
					[4] = { 88 },
					[5] = { 115 },
					[6] = { 190 },
					[7] = { 300 },
					[8] = { 370 },
		},
		[GetSpellInfo(1079)] = {
					["Name"] = "Rip",
					[0] = { Energy = 30, NoCrits = true, ComboPoints = true, Melee = true, requiresForm = 3, eDuration = 12, APBonus = { 0.06, 0.12, 0.18, 0.24, 0.3 }, Bleed = true },
					[1] = { 42, PerCombo = 24 },
					[2] = { 66, PerCombo = 42 },
					[3] = { 90, PerCombo = 54 },
					[4] = { 138, PerCombo = 84, },
					[5] = { 192, PerCombo = 120, },
					[6] = { 270, PerCombo = 168, },
					[7] = { 426, PerCombo = 282, },
					[8] = { 624, PerCombo = 432, },
					[9] = { 828, PerCombo = 594, },
		},
		[GetSpellInfo(5221)] = {
					["Name"] = "Shred",
					[0] = { Energy = 60, WeaponDamage = 2.25, Melee = true, requiresForm = 3 },
					[1] = { 54 },
					[2] = { 72 },
					[3] = { 99 },
					[4] = { 144 },
					[5] = { 180 },
					[6] = { 236 },
					[7] = { 405 },
					[8] = { 630 },
					[9] = { 742.5 },
		},
		[GetSpellInfo(1822)] = {
					["Name"] = "Rake",
					[0] = { Energy = 40, APBonus = 0.01, ExtraDamage = 0.18, E_eDuration = 9, Melee = true, requiresForm = 3, Bleed = true },
					[1] = { 17, Extra = 90 },
					[2] = { 26, Extra = 135 },
					[3] = { 46, Extra = 207 },
					[4] = { 64, Extra = 297 },
					[5] = { 90, Extra = 414 },
					[6] = { 150, Extra = 963 },
					[7] = { 190, Extra = 1161 },
		},
		[GetSpellInfo(22568)] = {
					["Name"] = "Ferocious Bite",
					[0] = { Energy = 35, ComboPoints = true, APBonus = 0.07, MaxPower = 30, PowerBonusAP = 1/410, Melee = true, requiresForm = 3 }, 
					[1] = { 50, 66, PerCombo = 36, PowerBonus = 0.7 },
					[2] = { 79, 103, PerCombo = 59, PowerBonus = 1.1 },
					[3] = { 122, 162, PerCombo = 92, PowerBonus = 1.5 },
					[4] = { 173, 223, PerCombo = 128, PowerBonus = 2 },
					[5] = { 199, 259, PerCombo = 147, PowerBonus = 2.1 },
					[6] = { 226, 292, PerCombo = 169, PowerBonus = 3.4 },
					[7] = { 334, 446, PerCombo = 236, PowerBonus = 7.7 },
					[8] = { 410, 550, PerCombo = 290, PowerBonus = 9.4 },
		},
		[GetSpellInfo(6785)] = {
					["Name"] = "Ravage",
					[0] = { Energy = 60, WeaponDamage = 3.85, Melee = true, requiresForm = 3 },
					[1] = { 161.7 },
					[2] = { 238.7 },
					[3] = { 300.3 },
					[4] = { 377.3 },
					[5] = { 565.95 },
					[6] = { 1405.25 },
					[7] = { 1771 },
		},
		[GetSpellInfo(9005)] = {
					["Name"] = "Pounce",
					[0] = { Energy = 50, NoCrits = true, APBonus = 0.18, Melee = true, requiresForm = 3, eDuration = 18, Bleed = true },
					[1] = { 270 },
					[2] = { 330 },
					[3] = { 450 },
					[4] = { 600 },
					[5] = { 2100 },
		},
		[GetSpellInfo(33878)] = {
					["Name"] = "Mangle (Bear)",
					[0] = { Rage = 20, WeaponDamage = 1.15, Melee = true, requiresForm = 1, Cooldown = 6 },
					[1] = { 86.25 },
					[2] = { 120.75 },
					[3] = { 155.25 },
					[4] = { 251.85 },
					[5] = { 299 },
		},
		[GetSpellInfo(33876)] = {
					["Name"] = "Mangle (Cat)",
					[0] = { Energy = 45, WeaponDamage = 2.00, Melee = true, requiresForm = 3, },
					[1] = { 198 },
					[2] = { 256 },
					[3] = { 330 },
					[4] = { 536 },
					[5] = { 634 },
		},
		[GetSpellInfo(22570)] = {
					["Name"] = "Maim",
					[0] = { Energy = 35, WeaponDamage = 1, ComboPoints = true, Melee = true, requiresForm = 3, Cooldown = 10 },
					[1] = { 129, 129, PerCombo = 84 },
					[2] = { 224, 224, PerCombo = 158 },
		},
		[GetSpellInfo(33745)] = {
					["Name"] = "Lacerate",
					[0] = { Rage = 15, APBonus = 0.01, Melee = true, ExtraDamage = 0.05, E_eDuration = 15, BleedExtra = true, requiresForm = 1 },
					[1] = { 31, Extra = 155 },
					[2] = { 70, Extra = 255 },
					[3] = { 88, Extra = 320 },
		},		
	}
	self.talentInfo = {
		--BALANCE:
		--Genesis (additive)
		[GetSpellInfo(57810)] = {	[1] = { Effect = .01, Spells = { "Rejuvenation", "Insect Swarm", "Wild Growth", "Tranquility", "Hurricane" } },
						[2] = { Effect = .01, Spells = { "Lifebloom", "Moonfire", "Regrowth" }, ModType = "dmgM_dot_Add" }, },
		--Nature's Majesty
		[GetSpellInfo(35363)] = { 	[1] = { Effect = 2, Spells = { "Wrath", "Starfire", "Starfall", "Nourish", "Healing Touch" }, ModType = "critPerc", }, },
		--Improved Moonfire (additive)
		[GetSpellInfo(16821)] = { 	[1] = { Effect = 5, Spells = "Moonfire", ModType = "critPerc", }, 
						[2] = { Effect = 0.05, Spells = "Moonfire", }, },
		--Brambles
		[GetSpellInfo(16836)] = {	[1] = { Effect = 0.25, Spells = { "Entangling Roots" }, }, },
		--Nature's Splendor
		[GetSpellInfo(57865)] = {	[1] = { Effect = 3, Spells = { "Moonfire", "Rejuvenation" }, ModType = "eDuration" },
						[2] = { Effect = 6, Spells = { "Regrowth" }, ModType = "eDuration" },
						[3] = { Effect = 2, Spells = { "Insect Swarm", "Lifebloom" }, ModType = "eDuration" }, },
		--Vengeance (additive)
		[GetSpellInfo(16909)] = { 	[1] = { Effect = 0.1, Spells = { "Starfire", "Starfall", "Moonfire", "Wrath" }, ModType = "critM", }, },
		--Improved Insect Swarm (multiplicative?)
		[GetSpellInfo(57849)] = {	[1] = { Effect = 1, Spells = { "Starfire", "Wrath" }, ModType = "Amount", Value = "Improved Insect Swarm", }, },
		--Moonfury (additive)
		[GetSpellInfo(16896)] = { 	[1] = { Effect = { 0.03, 0.06, 0.1 }, Spells = { "Starfire", "Moonfire", "Wrath" }, }, },
		--Balance of Power
		[GetSpellInfo(33592)] = { 	[1] = { Effect = 2, Spells = "All", Caster = true, ModType = "hitPerc" }, },
		--Improved Faerie Fire
		[GetSpellInfo(33600)] = { 	[1] = { Effect = 1, Spells = "All", Caster = true, ModType = "Amount", Value = "Improved Faerie Fire" }, },
		--Wrath of Cenarius (additive)
		[GetSpellInfo(33603)] = { 	[1] = { Effect = 0.04, Spells = "Starfire", ModType = "SpellDamage" },
						[2] = { Effect = 0.02, Spells = "Wrath", ModType = "SpellDamage"}, },
		--Gale Winds
		[GetSpellInfo(48488)] = {	[1] = { Effect = 0.15, Spells = { "Hurricane", "Typhoon" }, }, },
		--Earth and Moon (multiplicative?)
		[GetSpellInfo(48506)] = {	[1] = { Effect = 0.01, Spells = { "Moonfire", "Starfire", "Wrath", "Starfall", "Hurricane", "Typhoon", "Entangling Roots", "Insect Swarm" }, Multiply = true }, 
						[2] = { Effect = 0.01, Spells = "Starfire", ModType = "Amount", Value = "Earth And Moon" }, },
		--RESTORATION:
		--Naturalist
		[GetSpellInfo(17069)] = { 	[1] = { Effect = 0.02, Spells = "All", Caster = true, ModType = "Amount", Value = "Naturalist" }, },
		--Master Shapeshifter
		[GetSpellInfo(48411)] = {	[1] = { Effect = 0.02, Spells = "All", Caster = true, ModType = "Amount", Value = "Master Shapeshifter", }, },
		--Improved Rejuvenation (additive)
		[GetSpellInfo(17111)] = { 	[1] = { Effect = 0.05, Spells = "Rejuvenation" }, },
		--Gift of Nature (additive)
		[GetSpellInfo(17104)] = { 	[1] = { Effect = 0.02, Spells = "Healing" }, },		
		--Empowered Touch (additive)
		[GetSpellInfo(33879)] = { 	[1] = { Effect = 0.2, Spells = "Healing Touch", ModType = "SpellDamage" }, },		
		--Nature's Bounty
		[GetSpellInfo(17074)] = { 	[1] = { Effect = 5, Spells = { "Regrowth", "Nourish" }, ModType = "critPerc" }, },
		--Empowered Rejuvenation (multiplicative)
		[GetSpellInfo(33886)] = { 	[1] = { Effect = 0.04, Spells = { "Rejuvenation", "Regrowth", "Lifebloom", "Wild Growth", "Tranquility" }, ModType = "SpellDamage", Multiply = true, }, 
						[2] = { Effect = 0.04, Spells = { "Regrowth", "Lifebloom", }, ModType = "spellDmgM_dot", Multiply = true, }, },
		--Gift of the Earthmother
		[GetSpellInfo(51183)] = { 	[1] = { Effect = 0.04, Spells = { "Rejuvenation", "Lifebloom", "Wild Growth" }, ModType = "Gift of the Earthmother" }, },
		--TODO: Living Seed
		
		--FERAL:
		--Feral Aggression
		[GetSpellInfo(16858)] = { 	[1] = { Effect = 0.03, Spells = "Ferocious Bite", }, },
		--Feral Instinct
		[GetSpellInfo(16947)] = {	[1] = { Effect = 0.1, Spells = {"Swipe (Bear)", "Swipe (Cat)" }, }, },
		--Savage Fury
		[GetSpellInfo(16998)] = { 	[1] = { Effect = 0.1, Spells = { "Claw", "Rake", "Mangle (Cat)", "Mangle (Bear)", "Maul" }, }, },
		--Predatory Instincts
		[GetSpellInfo(33859)] = { 	[1] = { Effect = { 0.03, 0.07, 0.1 }, Spells = {"Swipe (Cat)", "Claw", "Rip", "Shred", "Rake", "Ferocious Bite", "Ravage", "Pounce", "Mangle (Cat)", "Maim"}, Melee = true, ModType = "critM" }, },
		--Rend and Tear
		[GetSpellInfo(48432)] = {	[1] = { Effect = 1, Spells = { "Maul", "Shred", "Ferocious Bite" }, ModType = "Amount", Value = "Rend and Tear", }, },
		--TODO: Primal Gore, makes Lacerate and Rip DoT able to crit
		--[GetSpellInfo(63503)] = {	[1] = { Effect = 1, Spells = { "Lacerate", "Rip" }, ModType = "Amount", Value = "Primal Gore", }, },
	}
end